using System;
namespace BTL
{
    public class MyPou606319703
    {
        // input
        public bool Button; // кнопка пешехода
        
        // output
        public bool R, Y, G; //светофор для машин
        public bool R2, G2; // светофор для пешеходов
        
        //local
        public bool BB; 
        public int B1 = 1;
        public int B1_Prev;
        public int B1_T;
        public bool B1_Pulse = true;
        public int B2 = 1;
        
        public void Process()
        {
            /*Code*/
            if (B1_Pulse)
            {
                B1_Prev = B1;
                B1_T = Environment.TickCount;
            }
            switch (B1)
            {
                /*машины едут, пешеходы стоят*/
                case 1: /*S1*/
                {
                    /*пешеход нажал кнопку*/
                    if (BB)
                    {
                        /*прошло ли достатоно времени для потока машин*/
                        if ((Environment.TickCount - B1_T) > 5000)
                        {
                            /*машинам желтый*/
                            B1 = 2; /*S2*/
                        }
                    }
                }
                break;
                /*машинам желтый*/
                case 2: /*S2*/
                {
                    /*выдержать желтый*/
                    if ((Environment.TickCount - B1_T) > 2000)
                    {
                        /*машины стоят, люди идут*/
                        B1 = 3; /*S3*/
                    }
                }
                break;
                /*машины стоят, люди идут*/
                case 3: /*S3*/
                {
                    /*пусть люди походят*/
                    if ((Environment.TickCount - B1_T) > 5000)
                    {
                        /*люди стоят, машинам желтый*/
                        B1 = 4; /*S4*/
                    }
                }
                break;
                /*люди стоят, машинам желтый*/
                case 4: /*S4*/
                {
                    /*коротенькая пауза*/
                    if ((Environment.TickCount - B1_T) > 1000)
                    {
                        /*машины едут, пешеходы стоят*/
                        B1 = 1; /*S1*/
                    }
                }
                break;
            }
            B1_Pulse = B1 != B1_Prev;
            switch (B2)
            {
                case 1: /*S1*/
                {
                    /*пешеход нажал кнопку*/
                    if (Button )
                    {
                        B2 = 2; /*S2*/
                    }
                }
                break;
                case 2: /*S2*/
                {
                    /*пешеход отжал кнопку*/
                    if (!(Button ))
                    {
                        B2 = 3; /*S3*/
                    }
                }
                break;
                case 3: /*S3*/
                {
                    B2 = 1; /*S1*/
                }
                break;
            }
            R = B1 == 3;
            Y = B1 == 2 || B1 == 4;
            G = B1 == 1;
            R2 = B1 == 1 || B1 == 4;
            G2 = B1 == 3;
            if (B1 == 4)
            {
                BB = false;
            }
            else
            {
                if (B2 == 3)
                {
                    BB = true;
                }
            }
            
            
        }
    }
}